#include <stdlib.h>
#include "SDL/SDL.h"
#include "display_scene.h"
#include "../common/scene.h"
#include "../common/debug.h"
#include "../common/oldbuffer.h"
#include "../misc/save_frame.h"
//#include "../../shader/noise.h"
#include "front_init.h"
#include "handle_input.h"
#include "console.h"
#include <time.h>
//#include <strings.h>
#include "globals.h"
#include "../common/scene.h"
#include "../common/misc.h"
#include "../common/Timer.h"
#include "../misc/save_frame.h"
#include "../misc/configDefines.h"
#include "../render/render_scene.h"

//extern clock_t current_time;
extern char frame_break_text[INPUT_COMMAND_LENGTH];

void process_buffer(SlimScene *scene)
{
	//static struct timespec sleeptime;
	
	//sleeptime.tv_sec = 0;
	//sleeptime.tv_nsec = 020000000;

	//if( handle_input() )
	handle_input(); 
		update_buffer(main_scene, frontend->screen);
	//else
	//	nanosleep(&sleeptime, NULL);
}

int frameNumber = 0;

int display_scene_loop(SlimScene *scene)
{

	printd(CRAZY, "Displaying scene\n");
	while( frontend->running )
	{
		static Timer renderTime;
		renderTime.start();
		
		render_scene(frontend->renderer);
		process_buffer(main_scene);
		frameNumber++;
		
		renderTime.stop();
		main_scene->last_render_time = renderTime.inMilliseconds();
		printf("time: %li\n", renderTime.inMilliseconds());
		print_frame_info(main_scene->last_render_time, 0);
#ifdef BLUR_TESTING
		//for testing: move camera a bit for the next frame
		//printf("real camera %.3f %.3f %.3f\n", main_scene->camera->pos[0], main_scene->camera->pos[1], main_scene->camera->pos[2]);
		//for conference
		//main_scene->camera->handleInput(20.0f, 0.0f);
		//for ball
		//main_scene->camera->pos = main_scene->camera->pos + (main_scene->camera->horz * -20);
		//main_scene->camera->pos = main_scene->camera->pos + (main_scene->camera->vert * -20);
		//main_scene->camera->setupCamera();
		//for teapots
		vector3 new_camera_pos = main_scene->camera->pos - main_scene->camera->lookAtPoint;
		new_camera_pos = new_camera_pos * 0.9;
		main_scene->camera->pos = new_camera_pos + main_scene->camera->lookAtPoint;
		if(frameNumber>2)
			exit(10);
#if BLUR == 0
		if(frameNumber==1)
			save_frame(main_scene);
#endif
		if(frameNumber==2)
			save_frame(main_scene);
#endif
	}

	return 1;
}

int update_buffer(SlimScene *scene, SDL_Surface* screen)
{
	Uint32* new_buffer;
	Uint8 R, G, B;
	Uint32 sdl_Color;
	int x,y;

	for(y=0; y < scene->height; y++)
	{
		for(x=0; x < main_scene->width; x++)
		{
			Color c = main_scene->colorOutput->getIndex(x,y);
			if(c.r>255.0)
				R = 255;
			else if(c.r<0.0)
				R = 0;
			else
				R = c.r;

			if(c.g>255.0)
				G = 255;
			else if(c.g<0.0)
				G = 0;
			else
				G = c.g;
			
			if(c.b>255.0)
				B = 255;
			else if(c.b<0.0)
				B = 0;
			else
				B = c.b;

			sdl_Color = SDL_MapRGB(screen->format, R, G, B);
			new_buffer = (Uint32*)screen->pixels + y * screen->pitch/4 + x;
			*new_buffer = sdl_Color;
		}
	}
	
	if(frontend->console_on)
	{
		draw_console(screen);
		print_to_bottom(frame_break_text);
	}

	//draw_buttons(screen);
	
	SDL_UpdateRect(frontend->screen, 0,0,0,0);
	
	printd(CRAZY, "Done copying buffer\n");

	return 1;
}

