#include "../common/scene.h"
#include "./bitmapUnix.h"
#include "./ppm.h"
#include "../common/debug.h"
#include <stdio.h>
#include <string.h>

extern SlimScene *main_scene;
extern int frameNumber;

void setup_filename(char *extension)
{
	/* set up the filenames */
	printd(ALERT, "Creating outname\n");
	strncpy(main_scene->outname, main_scene->filename, NAME_LENGTH);
	if( strstr(main_scene->filename, ".txt") )
		   main_scene->outname[strlen(main_scene->filename)-4] = '\0';
	if( strstr(main_scene->filename, ".obj") )
		   main_scene->outname[strlen(main_scene->filename)-4] = '\0';
	strcat( main_scene->outname, "_");
	int last_char = strlen(main_scene->outname);
	//sprintf( &main_scene->outname[last_char], "%i", main_scene->last_render_time);
	sprintf( &main_scene->outname[last_char], "%i", frameNumber);
	printf("%i\n", frameNumber);
	//strcat( main_scene->outname, "s");
	strcat( main_scene->outname, extension);
}

int save_frame(SlimScene* scene)
{
	printd(ALERT, "writing file out\n");
	//setup_filename(".ppm");
	//return (int) write_ppm( scene->outname,
	//		scene->width, scene->height, scene->Color_front);

	setup_filename(".bmp");
	
	Buffer<unsigned char> *image = new Buffer<unsigned char>(scene->width*scene->height*3);
	float *fColors = reinterpret_cast<float*> (main_scene->colorOutput->getDataPointer());
	for(int i=0; i<scene->width*scene->height*3; i++)
	{
		float f = *fColors;
		unsigned char uc;
		if(f>255.0)
			uc = 255;
		else if(f<0.0)
			uc = 0;
		else
			uc = f;

		image->setIndex(i, uc);
		fColors++;
	}
	return (int) write24BitBmpFile( scene->outname,
			scene->width, scene->height, image->getDataPointer());
}
	
