#ifndef HELP_TEXTS_TXT_
#define HELP_TEXTS_TXT_


char *set_scene_help_text =
"Edit scene options\n\
usage: set_scene <key> <value>\n\
\t\n\
keys:\n\
   sub_dis int   : distance between subsamples\n\
   sub_level int : min subsample distance\n\
   sub_var int   : subsamplematch variance\n\
   debug_level int  : debug- keep above 3\n\
   interpolate bool : enable interpolate\n\
   max_recurs int   : number of ray bounces\n\n";

char *set_camera_help_text =
"Edit camera options\n\
usage: set_camera <key> <value>\n\
\t\n\
keys:\n\
   units int    : fov control\n\
   pos vector   : camera position\n\
   look vector  : camera look point\n\
   up_vector vector : up vector\n\n";

char *set_Primitive_help_text =
"Edit individual Primitive settings\n\
usage: set_Primitive <objnum> <key> <value>\n\
\t\n\
keys:\n\
   radius float : radius (spheres)\n\
   pos vector    : position\n\
   normal vector : normal vector\n\
   shader string : use '?' for list\n\
\n";

char *set_render_help_text =
"Switch renderers\n\
usage: engine <engine>\n\
\t\n\
engines:\n\
   normal        : normal raytracer\n\
   sub_sampler   : subsampler\n\
   deferred      : subsampler, dererred shading\n\
   frameless     : frameless raytracing\n\
   frameless_sub : grid frameless subsampling\n\
   random_sub    : random frameless subsampling\n\
   super_sampler : super sampler\n\
   null          : no new rendering\n\
\n";

char *main_help_text = 
"Use 'command_name ?' for help. Some \n\
commands take arguments, see 'types' \n\
for input details.\n\
\t\n\
commands with help:\n\
   render	  : change the render engine\n\
   set_scene  : global settings\n\
   set_camera : camera settings\n\
   set_Primitive : individual Primitive settings\n\
   add_post : add a post-process shader\n\
   set_all_shaders : set all Primitive shaders\n\
\t\n\
commands without help:\n\
   save_frame          : saves a frame to disk\n\
   remove_post <int> : removes a post shader\n\
   load <path>         : loads a new scene\n\
\t\n\
types :\n\
   int    : 1\n\
   float : 0.5\n\
  vector3 : {1,2,3}\n\
   bool   : 0 (can be 0 or 1)\n\
   matrix : 3,3,{1,0,0,0,1,0,0,0,1}\n\
";

char *add_post_shader_help = 
"Add a post process shader\n\
usage: add_post <name> [options...]\n\
use: 'add_post <name> ?' for options\n\
use 'list_shaders' for a list of shaders\n\
\n";


#endif /*HELP_TEXTS_TXT_*/
