#include "../common/debug.h"
#include "../common/scene.h"
#include "FramelessSubSampler.h"
#include <stdlib.h>

void FramelessSubSamplingRayTracer::render(SlimScene *scene)
{
	int i, x, y;
	int distance = scene->sub_dis;
	printd(DEBUG, "entering render loop\n");

//	flush_Color_buffer();
	clear_idata_buffer();

	for(i=0; i<20; i++)
	{
//		//random points
//		x = (float)rand()/RAND_MAX * (main_scene->width - distance);
//		y = (float)rand()/RAND_MAX * (main_scene->height - distance);

		//grid points
		x = ((float)rand()/RAND_MAX) * (scene->width / distance);
		y = ((float)rand()/RAND_MAX) * (scene->height / distance);
		printd(CRAZY, "Sub-sample @  %i %i\n", x, y);
		calc_sub_sample(x * distance, y * distance, distance);
	}
}

void RandomSubSamplingRayTracer::render(SlimScene *scene)
{
	int i, x, y;
	int distance = scene->sub_dis;
	printd(DEBUG, "entering render loop\n");

//	flush_Color_buffer();
	clear_idata_buffer();

	for(i=0; i<20; i++)
	{
		//random points
		x = (float)rand()/RAND_MAX * (scene->width - distance);
		y = (float)rand()/RAND_MAX * (scene->height - distance);

		printd(CRAZY, "Sub-sample @  %i %i\n", x, y);
		calc_sub_sample(x, y, distance);
	}
}
