#ifndef __MOTIONBLURTRACER
#define __MOTIONBLURTRACER

#include "../common/scene.h"
#include "RayTracer.h"
#include "../misc/configDefines.h"

//#define STORE_MOTION_HITDATA
//#define STORE_MOTION_HITPOINT

class MotionBlurTracer : public RayTracer
{
public:
	MotionBlurTracer(Canvas *c) : RayTracer(c)
	{
	}
	
	~MotionBlurTracer()
	{ }
	
	void render(SlimScene *scene);
	
	inline void accumulateRay(float x, float y, SlimScene *scene, Camera &camera)
	{
		intersect_data i_data;
		Ray r = camera.getEyeRay(x, y);
		HitPoint h;
		Color c;
		
		if( scene->hierarchy->rayIntersectAll(r, h) )
		{
			i_data.step = 0;
			i_data.obj = h.primitivePtr;
			i_data.proj = r.getDir();
			i_data.intersect = h.pos;
			h.primitivePtr->shader(&i_data, &c);
#ifdef STORE_MOTION_HITPOINT
			scene->hitPoints->getIndex(x, y) = h.pos;
#endif
#ifdef STORE_MOTION_HITDATA
			//scene->hitData->getIndex(x, y).distance = h.distance;
			scene->hitData->getIndex(x, y) = h;
#endif
		}
		else
		{
			i_data.obj = h.primitivePtr;
			i_data.proj = r.getDir();
			i_data.intersect = h.pos;
			scene->background->shader(&i_data, &c);
#ifdef STORE_MOTION_HITDATA
			scene->hitData->getIndex(x, y).distance = 0.0f;
#endif
		}
		
		main_scene->colorOutput->getIndex(x,y) += c;
		//set_Color(x, y, &c);
	}
	
private:
	static const int numSamples = motionSamples;
	Camera cameraPrevious; // camera data from n-2	
	Camera cameraCurrent; // camera data from n-1
	Camera cameraFuture; // camera data from n-1
};

#endif 
