#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "../Primitives/PrimitiveBase.h"
#include "../common/Vector3.h"
#include "./shaders.h"

//#include "phong.h"
//#include "tracer.h"
#include "../common/scene.h"
#include "../common/debug.h"
#include "./lighting.h"

extern SlimScene* main_scene;
/*
 // {{{ diffuse light
void diffuse_light2(Color* c, intersect_data* id, int ln)
{
vector3 lightV;  //vector3 to light from point q
	vector3& intersectP = &id->intersect;
	float dpLN;
	float atten;
	float distance;

	// light vector
	lightV.c[0] = main_scene->lights[ln]->pos.c[0] - intersectP.c[0];
	lightV.c[1] = main_scene->lights[ln]->pos.c[1] - intersectP.c[1];
	lightV.c[2] = main_scene->lights[ln]->pos.c[2] - intersectP.c[2];
	lightV.normalize();



	printd(CRAZY, "diffuse lighting\n");
	dpLN = lightV.dot(id->normal).normalize();

	// directly perpendicular/behind Primitive
	if (dpLN <= 0)
		dpLN = 0;

	// light distance
	distance = sqrt( pow(main_scene->lights[ln]->pos.c[0]-id->obj->pos.c[0],2) +
			pow(main_scene->lights[ln]->pos.c[1]-id->obj->pos.c[1],2) +
			pow(main_scene->lights[ln]->pos.c[2]-id->obj->pos.c[2],2) );

	//atten = 1/(50+2*distance+1.5*pow(distance,2))*80;
	//atten = 1/pow(distance,2)*80;
	atten = 1/distance*20;
	//atten = 5/distance;
	//atten = 1;

	c->r += (id->obj->diff.r * dpLN *
		main_scene->lights[ln]->diff.r * atten);
	c->g += (id->obj->diff.g * dpLN *
		main_scene->lights[ln]->diff.g * atten);
	c->b += (id->obj->diff.b * dpLN *
			main_scene->lights[ln]->diff.b * atten);


}
// }}} 

//{{{ phong 
void diffuse_lighting(intersect_data *id, Color *new_Color)
{
vector3 lightV;  //vector3 to light from point q
	vector3 tracePt;	//1st Primitive on ray from Primitive to light
	PrimitiveBase* ob;
	vector3& intersectP = &id->intersect;
vector3 cameraV;
vector3 *norm = &id->normal;
	/vector3 *projV = &id->proj;

	float shadow = 1;
	float dpLN;
	float dpCR;
	//float distance;
	float atten;
	float gamma = id->obj->spec_alpha;
	//	float lightAngle;
	int i = 0;
	float distance;

	printd(DEBUG, "{phong\n");

	for(i=0; main_scene->lights[i]!=NULL; i++)
	{

		//ambient_light(new_Color, id, i);

		// if we are in a shadow, try the next light (ambient is the only
		// lighting needed and it is already done
		shadow = get_shadow(i, id);
		if ( shadow  <= 0)
			continue;

		diffuse_light2(new_Color, id, i);

		//specular_light(new_Color, id, i);
	}

	printd(CRAZY, "final lighting addition\n");
	// divide final value by the number of lighting calcs * max value
	//     3 * 255 = 765
	new_Color->r = new_Color->r/765*shadow;
	new_Color->g = new_Color->g/765*shadow;
	new_Color->b = new_Color->b/765*shadow;

	printd(DEBUG, "}exiting phong\n");
	//return local;
	return;
} //}}}
*/
